#ifndef TABLEGEN_SETTINGS_HPP
#define TABLEGEN_SETTINGS_HPP

#include <Common/RGB.hpp>

#include <string>

namespace Tablegen
{
    using Common::RGB;

    enum class Flag {
        Enable, Disable,
    };

    enum class FontSizeUnits {
        Px, Em,
    };
    std::string ToString(FontSizeUnits units);

    struct CharacterInfo
    {
        std::string Label;
        std::string ImagePath;
        std::string AnimationPath;
    };

    struct Settings
    {
        Flag                       FullDocument;

        Flag                       OverrideIndentLevel;
        std::size_t                IndentLevel;

        double                     TableWidth;
        double                     TableMargin;

        double                     TableItemWidth;
        double                     TableItemPadding;
        RGB                        TableItemColour;

        double                     LabelFontSize;
        FontSizeUnits              LabelFontUnits;
        RGB                        ButtonColour;
        RGB                        ButtonHoverColour;
        double                     ButtonAnimationLength;

        std::size_t                CharactersPerRow;
        std::string                ImageFormat;
        std::string                AnimationFormat;

        static Settings Default();
    };
}

#endif // TABLEGEN_SETTINGS_HPP
